import {palette} from "./palette.js";

const keysToSort = [
  "minecraft:killed_by", 
  "minecraft:broken", 
  "minecraft:used", 
  "minecraft:killed", 
  "minecraft:dropped", 
  "minecraft:crafted", 
  "minecraft:picked_up", 
  "minecraft:mined",
];

async function parseStats(stats) {
  let values = {
    valuedropped: [],
    datasdropped: [],
    valueused: [],
    datasused: [],
    valuecrafted: [],
    datascrafted: [],
    valuekilled_by: [],
    dataskilled_by: [],
    valuebroken: [],
    datasbroken: [],
    valuepicked_up: [],
    dataspicked_up: [],
    valuemined: [],
    datasmined: [],
    valuekilled: [],
    dataskilled: [],
  };
  // SORTING
  keysToSort.forEach((key) => {
    if (stats["stats"][key] && typeof stats["stats"][key] === "object") {
      stats["stats"][key] = Object.fromEntries(
        Object.entries(stats["stats"][key]).sort((a, b) => b[1] - a[1])
      );
    }
  });
  //parsing
  keysToSort.forEach((key) => {
    let statistic = stats["stats"][key];
    statistic = Object.fromEntries(Object.entries(statistic).slice(0, 10));
    let keyy = key.replace("minecraft:", "");
    for (let item in statistic) {
      values["value" + keyy].push(translate(item, key));
      values["datas" + keyy].push(statistic[item]);
    }
    createPie(values["value" + keyy], values["datas" + keyy], keyy);
  });
}

async function getStats() {
  const responsetranslate = await fetch("https://neroduck.ru/ru_edited.json", {
    method: "GET",
    headers: { Accept: "application/json" },
  });
  console.log(responsetranslate.ok);
  // если запрос прошел нормально
  if (responsetranslate.ok === true) {
    // получаем данные

    window.translatejson = await responsetranslate.json();
  }
  // отправляет запрос и получаем ответ
  const response = await fetch("https://neroduck.ru/nrdk.json", {
    method: "GET",
    headers: { Accept: "application/json" },
  });
  // если запрос прошел нормально
  if (response.ok === true) {
    // получаем данные
    const stats = await response.json();
    await parseStats(stats);
  }
  
}

function createPie(items, datas, idcanvas) {
  let bgcol = palette("tol-rainbow", items.length);
  for (let i = 0; i < bgcol.length; i++) {
    bgcol[i] = "#" + bgcol[i];
  }
  bgcol = bgcol.reverse();
  const data = {
    labels: items,
    datasets: [
      {
        label: "количество",
        data: datas,
        backgroundColor: bgcol,
        hoverOffset: 6,
      },
    ],
  };
  const config = {
    type: "doughnut",
    data: data,
    options: {
      plugins: {
        legend: {
          labels: {
            color: "white",
          },
        },
      },
    },
  };
  let canvas = document.getElementById(idcanvas);
  let chart = new Chart(canvas, config);
}

function translate(item, type) { 
  if (item.includes("minecraft:") === false) {
    return item;
  }
  let r;
  switch (type) {
    
    case "minecraft:killed_by":
      r = window.translatejson["entity." + item];
      return r;
    case "minecraft:broken":
      r = window.translatejson["item." + item]
      return r
    case "minecraft:used":
      r = window.translatejson["item." + item]
      if (r === undefined) {
        r = window.translatejson["block." + item];
      }
      return r
    case "minecraft:killed":
      r = window.translatejson["entity." + item]
      return r
    case "minecraft:dropped":
      r = window.translatejson["item." + item];
      if (r === undefined) {
        r = window.translatejson["block." + item];
      }
      return r
    case "minecraft:crafted":
      r = window.translatejson["item." + item]
      if (r === undefined) {
        r = window.translatejson["block." + item];
      }
      return r
    case "minecraft:picked_up":
      r = window.translatejson["item." + item]
      if (r === undefined) {
        r = window.translatejson["block." + item];
      }
      return r
    case "minecraft:mined":
      r = window.translatejson["block." + item]
      return r
  }
}


getStats();